#include <stdio.h>
#include "cpu.h"
#include "flags.h"

CPU_Regs cpu_regs;

Core core;


void CPU_Push16(Bitu value) {
	Bit32u new_esp= reg_esp-2;
	host_writew(core.base_ss + new_esp ,value);
	reg_esp=new_esp;
}

void CPU_Push32(Bitu value) {
	Bit32u new_esp= reg_esp-4;
	host_writed(core.base_ss + new_esp ,value);
	reg_esp=new_esp;
}

Bitu CPU_Pop16(void) {
	Bitu val=host_readw(core.base_ss + reg_esp);
	reg_esp= reg_esp+2;
	return val;
}

Bitu CPU_Pop32(void) {
	Bitu val=host_readd(core.base_ss + reg_esp );
	reg_esp= reg_esp+4;
	return val;
}

void IO_WriteB(Bitu port,Bitu val) {
	printf("OUTPUT VALUE:%02x\n",val);
}

void IO_WriteW(Bitu port,Bitu val) {
	printf("OUTPUT VALUE:%04x\n",val);
}

void IO_WriteD(Bitu port,Bitu val) {
	printf("OUTPUT VALUE:%08x\n",val);
}

Bitu IO_ReadB(Bitu port) {
	Bitu res;
	printf("ENTER BYTE VALUE (HEX):");
	scanf("%x",&res); 
	return res;
}

Bitu IO_ReadW(Bitu port) {
	Bitu res;
	printf("ENTER WORD VALUE (HEX):");
	scanf("%x",&res); 
	return res;
}

Bitu IO_ReadD(Bitu port) {
	Bitu res;
	printf("ENTER DWORD VALUE (HEX):");
	scanf("%x",&res); 
	return res;
}

void CPU_ENTER(Bitu bytes,Bitu level) {
	level&=0x1f;
	Bitu sp_index=reg_esp;
	Bitu bp_index=reg_ebp;
	sp_index-=4;
    host_writed(core.base_ss+sp_index,reg_ebp);
	reg_ebp=(reg_esp-4);
	if (level) {
		for (Bitu i=1;i<level;i++) {	
			sp_index-=4;bp_index-=4;
			host_writed(core.base_ss+sp_index,host_readd(core.base_ss+bp_index));
		}
		sp_index-=4;
		host_writed(core.base_ss+sp_index,reg_ebp);
	}
	sp_index-=bytes;
	reg_esp=sp_index;
}


bool CPU_CLI(void) {
		reg_flags&=~FLAG_IF;
		return false;
}

bool CPU_STI(void) {
 		reg_flags|=FLAG_IF;
		return false;
}

void CPU_SetFlags(Bitu word,Bitu mask) {
	reg_flags=(reg_flags & ~mask)|(word & mask)|2;
	//cpu.direction=1-((reg_flags & FLAG_DF) >> 9);
}


bool CPU_POPF(Bitu use32) {
	Bitu mask=FMASK_ALL;
	/* IOPL field can only be modified when CPL=0 or in real mode: */
	CPU_SetFlags(CPU_Pop32(),mask);
	DestroyConditionFlags();
	return false;
}

bool CPU_PUSHF(Bitu use32) {
	FillFlags();
	CPU_Push32(reg_flags & 0xfcffff);
	return false;
}

void CPU_HLT(Bitu oldeip) {
	reg_eip=oldeip;
}
