#ifndef MEMORY_H
#define MEMORY_H

typedef Bit8u * HostPt;

typedef HostPt (*GetEAHandler)(void);

extern HostPt MemBase;

void MEM_Init(Bitu memsize);

static inline Bit8u host_readb(HostPt off) {
	return *(Bit8u *)off;
}
static inline Bit16u host_readw(HostPt off) {
	return *(Bit16u *)off;
}
static inline Bit32u host_readd(HostPt off) {
	return *(Bit32u *)off;
}
static inline void host_writeb(HostPt off,Bit8u val) {
	*(Bit8u *)(off)=val;
}
static inline void host_writew(HostPt off,Bit16u val) {
	*(Bit16u *)(off)=val;
}
static inline void host_writed(HostPt off,Bit32u val) {
	*(Bit32u *)(off)=val;
}

#endif
