
/* The MOD/RM Decoder for EA for this decoder's addressing modes */
static HostPt EA_16_00_n(void) { return core.base_ds+(Bit16u)(reg_bx+(Bit16s)reg_si); }
static HostPt EA_16_01_n(void) { return core.base_ds+(Bit16u)(reg_bx+(Bit16s)reg_di); }
static HostPt EA_16_02_n(void) { return core.base_ss+(Bit16u)(reg_bp+(Bit16s)reg_si); }
static HostPt EA_16_03_n(void) { return core.base_ss+(Bit16u)(reg_bp+(Bit16s)reg_di); }
static HostPt EA_16_04_n(void) { return core.base_ds+(Bit16u)(reg_si); }
static HostPt EA_16_05_n(void) { return core.base_ds+(Bit16u)(reg_di); }
static HostPt EA_16_06_n(void) { return core.base_ds+(Bit16u)(Fetchw());}
static HostPt EA_16_07_n(void) { return core.base_ds+(Bit16u)(reg_bx); }

static HostPt EA_16_40_n(void) { return core.base_ds+(Bit16u)(reg_bx+(Bit16s)reg_si+Fetchb()); }
static HostPt EA_16_41_n(void) { return core.base_ds+(Bit16u)(reg_bx+(Bit16s)reg_di+Fetchb()); }
static HostPt EA_16_42_n(void) { return core.base_ss+(Bit16u)(reg_bp+(Bit16s)reg_si+Fetchb()); }
static HostPt EA_16_43_n(void) { return core.base_ss+(Bit16u)(reg_bp+(Bit16s)reg_di+Fetchb()); }
static HostPt EA_16_44_n(void) { return core.base_ds+(Bit16u)(reg_si+Fetchb()); }
static HostPt EA_16_45_n(void) { return core.base_ds+(Bit16u)(reg_di+Fetchb()); }
static HostPt EA_16_46_n(void) { return core.base_ss+(Bit16u)(reg_bp+Fetchb()); }
static HostPt EA_16_47_n(void) { return core.base_ds+(Bit16u)(reg_bx+Fetchb()); }

static HostPt EA_16_80_n(void) { return core.base_ds+(Bit16u)(reg_bx+(Bit16s)reg_si+Fetchw()); }
static HostPt EA_16_81_n(void) { return core.base_ds+(Bit16u)(reg_bx+(Bit16s)reg_di+Fetchw()); }
static HostPt EA_16_82_n(void) { return core.base_ss+(Bit16u)(reg_bp+(Bit16s)reg_si+Fetchw()); }
static HostPt EA_16_83_n(void) { return core.base_ss+(Bit16u)(reg_bp+(Bit16s)reg_di+Fetchw()); }
static HostPt EA_16_84_n(void) { return core.base_ds+(Bit16u)(reg_si+Fetchw()); }
static HostPt EA_16_85_n(void) { return core.base_ds+(Bit16u)(reg_di+Fetchw()); }
static HostPt EA_16_86_n(void) { return core.base_ss+(Bit16u)(reg_bp+Fetchw()); }
static HostPt EA_16_87_n(void) { return core.base_ds+(Bit16u)(reg_bx+Fetchw()); }

static Bit32u SIBZero=0;
static Bit32u * SIBIndex[8]= { &reg_eax,&reg_ecx,&reg_edx,&reg_ebx,&SIBZero,&reg_ebp,&reg_esi,&reg_edi };

static inline HostPt Sib(Bitu mode) {
	Bit8u sib=Fetchb();
	HostPt base;
	switch (sib&7) {
	case 0:	/* EAX Base */
		base=core.base_ds+reg_eax;break;
	case 1:	/* ECX Base */
		base=core.base_ds+reg_ecx;break;
	case 2:	/* EDX Base */
		base=core.base_ds+reg_edx;break;
	case 3:	/* EBX Base */
		base=core.base_ds+reg_ebx;break;
	case 4:	/* ESP Base */
		base=core.base_ss+reg_esp;break;
	case 5:	/* #1 Base */
		if (!mode) {
			base=core.base_ds+Fetchd();break;
		} else {
			base=core.base_ss+reg_ebp;break;
		}
	case 6:	/* ESI Base */
		base=core.base_ds+reg_esi;break;
	case 7:	/* EDI Base */
		base=core.base_ds+reg_edi;break;
	}
	base+=*SIBIndex[(sib >> 3) &7] << (sib >> 6);
	return base;
}

static HostPt EA_32_00_n(void) { return core.base_ds+reg_eax; }
static HostPt EA_32_01_n(void) { return core.base_ds+reg_ecx; }
static HostPt EA_32_02_n(void) { return core.base_ds+reg_edx; }
static HostPt EA_32_03_n(void) { return core.base_ds+reg_ebx; }
static HostPt EA_32_04_n(void) { return Sib(0);}
static HostPt EA_32_05_n(void) { return core.base_ds+Fetchd(); }
static HostPt EA_32_06_n(void) { return core.base_ds+reg_esi; }
static HostPt EA_32_07_n(void) { return core.base_ds+reg_edi; }

static HostPt EA_32_40_n(void) { return core.base_ds+reg_eax+Fetchb(); }
static HostPt EA_32_41_n(void) { return core.base_ds+reg_ecx+Fetchb(); }
static HostPt EA_32_42_n(void) { return core.base_ds+reg_edx+Fetchb(); }
static HostPt EA_32_43_n(void) { return core.base_ds+reg_ebx+Fetchb(); }
static HostPt EA_32_44_n(void) { HostPt temp=Sib(1);return temp+Fetchb();}
//static HostPt EA_32_44_n(void) { return Sib(1)+Fetchb();}
static HostPt EA_32_45_n(void) { return core.base_ss+reg_ebp+Fetchb(); }
static HostPt EA_32_46_n(void) { return core.base_ds+reg_esi+Fetchb(); }
static HostPt EA_32_47_n(void) { return core.base_ds+reg_edi+Fetchb(); }

static HostPt EA_32_80_n(void) { return core.base_ds+reg_eax+Fetchd(); }
static HostPt EA_32_81_n(void) { return core.base_ds+reg_ecx+Fetchd(); }
static HostPt EA_32_82_n(void) { return core.base_ds+reg_edx+Fetchd(); }
static HostPt EA_32_83_n(void) { return core.base_ds+reg_ebx+Fetchd(); }
static HostPt EA_32_84_n(void) { HostPt temp=Sib(2);return temp+Fetchd();}
//static HostPt EA_32_84_n(void) { return Sib(2)+Fetchd();}
static HostPt EA_32_85_n(void) { return core.base_ss+reg_ebp+Fetchd(); }
static HostPt EA_32_86_n(void) { return core.base_ds+reg_esi+Fetchd(); }
static HostPt EA_32_87_n(void) { return core.base_ds+reg_edi+Fetchd(); }

static GetEAHandler EATable[512]={
/* 00 */
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
	EA_16_00_n,EA_16_01_n,EA_16_02_n,EA_16_03_n,EA_16_04_n,EA_16_05_n,EA_16_06_n,EA_16_07_n,
/* 01 */
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
	EA_16_40_n,EA_16_41_n,EA_16_42_n,EA_16_43_n,EA_16_44_n,EA_16_45_n,EA_16_46_n,EA_16_47_n,
/* 10 */
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
	EA_16_80_n,EA_16_81_n,EA_16_82_n,EA_16_83_n,EA_16_84_n,EA_16_85_n,EA_16_86_n,EA_16_87_n,
/* 11 These are illegal so make em 0 */
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
/* 00 */
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
	EA_32_00_n,EA_32_01_n,EA_32_02_n,EA_32_03_n,EA_32_04_n,EA_32_05_n,EA_32_06_n,EA_32_07_n,
/* 01 */
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
	EA_32_40_n,EA_32_41_n,EA_32_42_n,EA_32_43_n,EA_32_44_n,EA_32_45_n,EA_32_46_n,EA_32_47_n,
/* 10 */
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
	EA_32_80_n,EA_32_81_n,EA_32_82_n,EA_32_83_n,EA_32_84_n,EA_32_85_n,EA_32_86_n,EA_32_87_n,
/* 11 These are illegal so make em 0 */
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,
	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0,	0
};



